program tpenv
  use psb_penv_mod

  implicit none 

  integer :: ictxt, ictxt2, ictxt3, iam, np, info 

  integer :: comm1, comm2, comm3
  integer :: group1, group2, group3
  integer :: np1, np2, np3, n2, n3
  integer :: iam1, iam2, iam3
  integer :: i,j, isnullcomm, idummy
  integer, allocatable :: ids(:), itstv(:),itstm(:,:)
  integer(psb_long_int_k_), allocatable :: i8tstv(:),i8tstm(:,:)
  real(psb_spk_), allocatable :: ststv(:),ststm(:,:)
  real(psb_dpk_), allocatable :: dtstv(:),dtstm(:,:)
  complex(psb_spk_), allocatable :: ctstv(:),ctstm(:,:)
  complex(psb_dpk_), allocatable :: ztstv(:),ztstm(:,:)
  logical, allocatable :: ltstv(:),ltstm(:,:)

  character(len=60) :: string 

  logical :: initialized

  call psb_init(ictxt)

  write(*,*)  'From init ',ictxt
  call psb_barrier(ictxt)
  call psb_info(ictxt,iam,np)
  write(*,*)  'From info ',ictxt,iam,np
  call psb_barrier(ictxt)

  n2 = max(1,np/2)
  call psb_init(ictxt2,np=n2,basectxt=ictxt)
  write(*,*)  'From init1 ',ictxt2
  call psb_info(ictxt2,iam2,np2)
  write(*,*)  'From info1 ',ictxt2,iam,np,iam2,np2
  call psb_barrier(ictxt)
  
  n3 = n2
  allocate(ids(n3))
  do i = 1, n3
    ids(i) = np - i
  end do
  call psb_init(ictxt3,np=n3,basectxt=ictxt,ids=ids)
  write(*,*)  'From init1 ',ictxt3
  call psb_info(ictxt3,iam3,np3)
  write(*,*)  'From info1 ',ictxt3,iam,np,iam3,np3
  call psb_barrier(ictxt)


  if (np > 1) then 
    allocate(itstv(10),itstm(10,10))
    allocate(i8tstv(10),i8tstm(10,10))
    allocate(ststv(10),ststm(10,10))
    allocate(dtstv(10),dtstm(10,10))
    allocate(ctstv(10),ctstm(10,10))
    allocate(ztstv(10),ztstm(10,10))
    allocate(ltstv(10),ltstm(10,10))
    if (iam == 0) then 
      idummy = -4
      do i=1,10 
        itstv(i) = idummy + i 
      end do
      do j=1,4
        do i=1,4
          itstm(i,j) = j*idummy+i + 8
        end do
      end do
      i8tstv = itstv
      ststv = itstv
      dtstv = itstv
      ctstv = itstv
      ztstv = itstv
      ltstv = (itstv > 0)
      i8tstm = itstm
      ststm = itstm
      dtstm = itstm
      ctstm = itstm
      ztstm = itstm
      ltstm = (itstm > 0)

      call psb_snd(ictxt,idummy,1)
      call psb_snd(ictxt,itstv,1)
      call psb_snd(ictxt,itstm(:,1:4),1,m=4)
      call psb_snd(ictxt,i8tstv,1)
      call psb_snd(ictxt,i8tstm(:,1:4),1,m=4)
      call psb_snd(ictxt,ststv,1)
      call psb_snd(ictxt,ststm(:,1:4),1,m=4)
      call psb_snd(ictxt,dtstv,1)
      call psb_snd(ictxt,dtstm(:,1:4),1,m=4)
      call psb_snd(ictxt,ctstv,1)
      call psb_snd(ictxt,ctstm(:,1:4),1,m=4)
      call psb_snd(ictxt,ztstv,1)
      call psb_snd(ictxt,ztstm(:,1:4),1,m=4)
      call psb_snd(ictxt,ltstv,1)
      call psb_snd(ictxt,ltstm(:,1:4),1,m=4)
      string = 'the quick brown fox jumps over the lazy dog'
      call psb_snd(ictxt,string,1)

    else if (iam == 1) then 
      call psb_rcv(ictxt,idummy,0)
      write(*,*) iam,' Receive from 0:',idummy

      call psb_rcv(ictxt,itstv,0)
      write(*,*) iam,' Receive from 0:',itstv(1:4)
      call psb_rcv(ictxt,itstm(:,1:4),0,m=4)
      do i=1, 4
        write(*,*) iam,i,' Receive from 0:',itstm(i,1:4)
      end do

      call psb_rcv(ictxt,i8tstv,0)
      write(*,*) iam,' Receive from 0:',i8tstv(1:4)
      call psb_rcv(ictxt,i8tstm(:,1:4),0,m=4)
      do i=1, 4
        write(*,*) iam,i,' Receive from 0:',i8tstm(i,1:4)
      end do

      call psb_rcv(ictxt,ststv,0)
      write(*,*) iam,' Receive from 0:',ststv(1:4)
      call psb_rcv(ictxt,ststm(:,1:4),0,m=4)
      do i=1, 4
        write(*,*) iam,i,' Receive from 0:',ststm(i,1:4)
      end do

      call psb_rcv(ictxt,dtstv,0)
      write(*,*) iam,' Receive from 0:',dtstv(1:4)
      call psb_rcv(ictxt,dtstm(:,1:4),0,m=4)
      do i=1, 4
        write(*,*) iam,i,' Receive from 0:',dtstm(i,1:4)
      end do

      call psb_rcv(ictxt,ctstv,0)
      write(*,*) iam,' Receive from 0:',ctstv(1:4)
      call psb_rcv(ictxt,ctstm(:,1:4),0,m=4)
      do i=1, 4
        write(*,*) iam,i,' Receive from 0:',ctstm(i,1:4)
      end do

      call psb_rcv(ictxt,ztstv,0)
      write(*,*) iam,' Receive from 0:',ztstv(1:4)
      call psb_rcv(ictxt,ztstm(:,1:4),0,m=4)
      do i=1, 4
        write(*,*) iam,i,' Receive from 0:',ztstm(i,1:4)
      end do

      call psb_rcv(ictxt,ltstv,0)
      write(*,*) iam,' Receive from 0:',ltstv(1:4)
      call psb_rcv(ictxt,ltstm(:,1:4),0,m=4)
      do i=1, 4
        write(*,*) iam,i,' Receive from 0:',ltstm(i,1:4)
      end do

      call psb_rcv(ictxt,string,0)
      write(*,*) iam,'Received from 0: "',string,'"'


    end if
  end if

  call psb_exit(ictxt2, close=.false.)
  call psb_exit(ictxt3, close=.false.)
  
  call psb_exit(ictxt)

end program tpenv
